<template>
  <div class="product pt-3">
    <div class="container" v-if="product.length">
      <div class="grid grid-cols-2 wrap">
        <div class="mx-auto">
          <img
              :src="
                (!product.options_new && product.image) ||
                (selectedProductView >= 0 && product.images[selectedProductView].thumb)
              "
              class="w-full mb-2 mx-auto product-image"
              :alt="product.name"
          >
          <div class="flex preview-image-wrap">
            <div
                v-for="(img, index) in product.images"
                :key="img.thumb + index"
                class="pointer mx-1"
                @click="selectProductOnImage(index, img.product_id)"
                :class="{'active':selectedProductView === index}"
            >
              <img :src="img.popup" :alt="product.name">
            </div>
          </div>
        </div>
        <div class="sm:pt-6">
          <div v-if="product.akcia !== '0'">
            <div class="color-red text-4xl text-center mb-1">Акция!</div>
            <div class="text-center mb-6"><span class="color-red">Товар дня!</span> Успей купить со скидкой!</div>
          </div>
          <div class="mb-6 sm:mb-8 lg:mb-14 grid items-center product-title">
            <div
                v-if="product.price !== '0.0000'"
                class="text-center sm:text-left text-3xl"
                style="white-space: nowrap;"
            >
              {{Math.floor(product.price * 100) / 100}} ₽
            </div>
            <div
                v-else
                class="text-center sm:text-left text-3xl"
                style="white-space: nowrap;"
            >
              {{Math.floor(product.options_new[selectedProductView].price * 100) / 100}} ₽
            </div>
            <div>{{product.name}}</div>
          </div>
          <div v-if="product.options_new && product.options_new[selectedProductView].product_options" class="mb-4">
            <div class="text-gray-500 text-sm mb-2">Параметры:</div>
            <div class="grid" :class="'grid-cols-'+product.options_new[selectedProductView].product_options.length">
              <div
                  v-for="option in product.options_new[selectedProductView].product_options"
                  :key="option"
                  class="grid items-center pl-4"
                  :class="'grid-rows-'+product.options_new[selectedProductView].product_options.length"
              >
                <span class="text-xs opacity-50">{{option.name}}</span>
                {{option.value}}
              </div>
            </div>
          </div>
          <div class="mb-4">
            <div class="text-gray-500 text-sm">Наличие:</div>
            <div>{{product.stock}}</div>
          </div>
          <div class="mb-4">
            <div class="text-gray-500 text-sm">Количество:</div>
            <div>{{
                (!product.options_new && product.quantity) || (product.options_new && product.options_new[selectedProductView].quantity)
              }} шт.</div>
          </div>
          <div class="mb-4">
            <div class="text-gray-500 text-sm">Производитель:</div>
            <div>{{product.manufacturer}}</div>
          </div>
          <div class="mb-4">
            <div class="text-gray-500 text-sm">Артикул:</div>
            <div>{{product.model}}</div>
          </div>

          <div class="button mx-auto w-full sm:w-1/2 mt-6 sm:mt-12 lg:mt-20">Заказать</div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import {ref, onMounted, computed} from 'vue'
import { useRoute } from 'vue-router'
import {useStore} from "vuex";
import {getDatabase, onValue, ref as fireRef} from "firebase/database";
export default {
  name: "Product",
  setup() {
    const route = useRoute()
    const store = useStore()
    const product = ref({})
    const selectedProductView = ref(0)
    const selectedProductId = ref('')

    async function getProduct (index = 0) {
      const db = await getDatabase();
      const starCountRef = await fireRef(db, '/shop/' + route.params.category + '/products/' + route.params.product);
      await onValue(starCountRef, (snapshot) => {
        if (snapshot.val() !== null) {
          product.value = snapshot.val()
        } else console.log('Ошибка при запросе к ' + '/shop/' + route.params.category + '/products/' + route.params.product)
      });
    }

    function selectProductOnImage(index, id) {
      selectedProductId.value = id
      selectedProductView.value = index
    }
    let products = computed(function () {
      return store.state.shop
    });
    onMounted(()=>{
      if (products.length) {
        products.forEach(el=> el.product_id === route.params.id && (product.value = el))
        // for (let el in store.shop) {
        //   el === route.params.product  && (product.value = el)
        // }state.
      } else {
        getProduct()
      }
    })
    return {
      store,
      product,
      selectedProductView,
      selectedProductId,
      selectProductOnImage,
    }
  }
}
</script>

<style scoped lang="scss">
.product {
  .wrap {
    grid-template-columns: 3fr 2fr;
    .product-title {
      grid-template-columns: 1fr 3fr;
      @media (max-width: 500px) {
        grid-template-columns: 1fr;
        grid-template-rows: 1fr 2fr;
        grid-row-gap: 1em;
      }
    }
    @media (max-width: 800px) {
      grid-template-columns: 1fr;
      grid-template-rows: 1fr 1fr;
      grid-row-gap: 3em;
    }
    @media (max-width: 500px) {
      grid-template-columns: 1fr;
      grid-template-rows: 1fr 2fr;
      grid-row-gap: 3em;
    }
  }
  .product-image {
    @media (min-width: 1000px) {
      max-width: 80%;
    }
  }
  .preview-image-wrap {
    height: 100px;
    max-height: 100px;
    overflow-x: auto;
    max-width: 600px;
    div {
      width: 50px;
    }
  }
  .active {
    border: 1px dashed rgba(213,40,40, .3);
  }
}
</style>
